﻿angular.module('mallista.i18n.service', [])
    .factory('TranslatorService', [function () {
        var self = this;
        var currentLan;
        var defaultLan = "ca";

        //Language list with its attributes
        var languages = [
            //CATALÀ
            {
                name: "Català",
                id: "ca",
                tokens: {
                    ABOUT: "Sobre MaLlista",
                    ABOUT_LINE_1: "Creada per Josep Antoni Casas Lopez<br />com a Treball Fi de Carrera<br />Enginyeria Tècnica d'Informàtica de Gestió<br />Universitat Oberta de Catalunya",
                    ABOUT_LINE_2: "Consultors:<br />Antonio Rodríguez Gutiérrez<br />Carlos Sánchez Rosa",
                    ABOUT_LINE_3: "Agraiments especials a:",
                    ABOUT_LINE_4: "<i>Isa, Eder i Raquel</i>, per tot el suport que sempre m'han brindat.",
                    ACCEPT: "Acceptar",
                    ACTIVATED: "Activat",
                    ALL_LISTS: "Totes les llistes",
                    APP_NAME: "MaLlista",
                    APP_VERSION: "Versió {0}",
                    BRAND: "Marca",
                    BRANDS: "Marques",
                    BUY: "Comprar",
                    BUY_PRODUCT: "Comprar Producte",
                    CANCEL: "Cancel.lar",
                    CATEGORY: "Categoria",
                    CATEGORIES: "Categories",
                    CLOSE: "Tancar",
                    CODE: "Codi",
                    CREATE_LIST: "Crear Nova Llista",
                    CREATE_PENDING: "Afegir Producte a Pendent",
                    CREATE_PRODUCT: "Crear Nou Producte",
                    CREATE_REGISTER: "Afegir Fila",
                    CREATION_DATE: "Data creació",
                    CREATION_TIME: "Hora creació",
                    DATE: "Data",
                    DELETE: "Eliminar",
                    DELETE_LIST_BODY: "Estàs segur que vols eliminar la llista de la compra</br>'<b>{0}</b>'?",
                    DELETE_LIST_TITLE: "Eliminar llista",
                    DELETE_PENDING_BODY: "Estàs segur que vols treure el producte</br>'<b>{0}</b>'</br>de la llista de la compra</br>'<b>{1}</b>'?",
                    DELETE_PENDING_TITLE: "Treure producte",
                    DELETE_PRODUCT_BODY: "Estàs segur que vols eliminar el producte</br>'<b>{0}</b>'?",
                    DELETE_PRODUCT_TITLE: "Eliminar producte",
                    DELETE_REGISTER_BODY: "Estàs segur que vols eliminar el registre seleccionat?",
                    DELETE_REGISTER_TITLE: "Eliminar registre",
                    DELETING_DATA: "Eliminant",
                    DESCRIPTION: "Descripció",
                    EDIT: "Modificar",
                    EDIT_LIST: "Modificar Llista",
                    EDIT_PRODUCT: "Modificar Producte",
                    EDIT_REGISTER: "Modificar Fila",
                    END_DATE: "Data Final",
                    ERROR_DATABASE: "S'ha produït un error a la base de dades.",
                    ERROR_REGISTERED: "'<b>{0}</b>'</br>ja existeix o forma part de l'arxiu històric!!!</br></br>(MaLlista no permet la repetició de noms)",
                    ESTABLISHMENT: "Establiment",
                    ESTABLISHMENTS: "Establiments",
                    GENERATING_REPORT: "Generant l'informe",
                    HOME: "Inici",
                    IDENTIFIER: "Identificador",
                    IMAGE: "Imatge",
                    INITIALIZING: "Preparant l'inici",
                    INVALID_FORM: "Les dades del formulari no són correctes!!!",
                    LANGUAGE: "Idioma",
                    LATITUDE: "Latitud",
                    LIST_NAME: "Nom de la llista",
                    LISTS: "Llistes",
                    LOADING_DATA: "Carregant dades",
                    LONGITUDE: "Longitud",
                    MAINTENANCE: "Manteniment",
                    MENU_TOOLS: "Eines",
                    MESSAGE_TITLE: "Missatge de MaLlista",
                    MODIFICATION_DATE: "Data última modificació",
                    MODIFICATION_TIME: "Hora última modificació",
                    NAME: "Nom",
                    NAME_REQUIRED: "Si us plau, indica el nom",
                    NO_DATA_FOUND: "No s'han trobat dades!!!",
                    NO_LIST_FOUND: "No s'han trobat llistes!!!",
                    NO_PRODUCT_FOUND: "No s'han trobat productes!!!",
                    NO_REGISTER_FOUND: "No s'han trobat registres!!!",
                    NO_ROW_SELECTED: "Si us plau, selecciona una fila!!!",
                    NONE: "Sense especificar",
                    PENDING: "Pendent",
                    PREFERRED_ESTABLISHMENT: "Establiment preferit",
                    PRODUCT: "Producte",
                    PRODUCT_NAME: "Nom del producte",
                    PRODUCT_REMARKS: "Observacions del producte",
                    PRODUCTS: "Productes",
                    PURCHASED_PRODUCTS_PER_PERIOD: "Productes Comprats per Període",
                    PURCHASED_QTY: "Quantitat comprada",
                    PURCHASES: "Compres",
                    QUANTITY: "Quantitat",
                    REMARKS: "Observacions",
                    REPORT_RANGE: "Del {0} al {1}",
                    REQUESTED_QTY: "Quantitat a comprar",
                    REQUIRED: "Requerit",
                    RUN_REPORT: "Generar Informe",
                    SAVE: "Desar",
                    SAVING_DATA: "Desant",
                    SELECT_DATE: "Seleccionar Data",
                    SET: "OK",
                    SETTINGS: "Configuració",
                    SHOPPING_LIST: "Llista de la Compra",
                    SHOPPING_LIST_PRODUCTS: "Productes pendents",
                    SHOPPING_LIST_REMARKS: "Observacions de la llista de la compra",
                    SHOPPING_LISTS: "Llistes de la compra",
                    SHOW_LIST: "Detalls de la Llista",
                    SHOW_PENDING: "Detalls del Producte Pendent",
                    SHOW_PICTURE_IN_PENDING: "Mostrar imatges a Pendents",
                    SHOW_PICTURE_IN_PRODUCT: "Mostrar imatges a Productes",
                    SHOW_PRODUCT: "Detalls del Producte",
                    START_DATE: "Data d'Inici",
                    STATISTICS: "Estadístiques",
                    TIME: "Hora",
                    TODAY: "Avui",
                    TOTAL_AMOUNT: "Import total",
                    TOTAL_AMOUNT_PER_BRAND: "Import Gastat per Marca",
                    TOTAL_AMOUNT_PER_CATEGORY: "Import Gastat per Categoria",
                    TOTAL_AMOUNT_PER_ESTABLISHMENT: "Import Gastat per Establiment",
                    TOTAL_AMOUNT_PER_PERIOD: "Import Gastat per Període",
                    TOTAL_PERIOD: "Total període",
                    UNABLE_TO_DELETE: "No es poden eliminar els registres d'aquesta taula",
                    UNEXPECTED_ERROR: "S'ha produït un error inesperat!!!",
                    UNIT_PRICE: "Preu Unitari",
                    UNITS: "Unitats",
                    VIEW_DETAILS: "Mostrar",
                }
            },
            //ENGLISH
            {
                name: "English",
                id: "en",
                tokens: {
                    ABOUT: "About MaLlista",
                    ABOUT_LINE_1: "Created by Josep Antoni Casas Lopez<br />as Bacherlor's Degree Thesis<br />Technical Engineering in Computer Management<br />Universitat Oberta de Catalunya",
                    ABOUT_LINE_2: "Consultants:<br />Antonio Rodríguez Gutiérrez<br />Carlos Sánchez Rosa",
                    ABOUT_LINE_3: "Special thanks to:",
                    ABOUT_LINE_4: "<i>Isa, Eder and Raquel</i>, for all the support they have always given me.",
                    ACCEPT: "Accept",
                    ACTIVATED: "Activated",
                    ALL_LISTS: "All shopping lists",
                    APP_NAME: "MaLlista",
                    APP_VERSION: "Version {0}",
                    BRAND: "Brand",
                    BRANDS: "Brands",
                    BUY: "Buy",
                    BUY_PRODUCT: "Buy Product",
                    CANCEL: "Cancel",
                    CATEGORY: "Category",
                    CATEGORIES: "Categories",
                    CLOSE: "Close",
                    CODE: "Code",
                    CREATE_LIST: "New Shopping List",
                    CREATE_PENDING: "Add Product to Pending",
                    CREATE_PRODUCT: "New Product",
                    CREATE_REGISTER: "Add Row",
                    CREATION_DATE: "Creation date",
                    CREATION_TIME: "Creation time",
                    DATE: "Date",
                    DELETE: "Delete",
                    DELETE_LIST_BODY: "Do you want to delete the shopping list</br>'<b>{0}</b>'?",
                    DELETE_LIST_TITLE: "Delete shopping list",
                    DELETE_PENDING_BODY: "Do you want to remove the product</br>'<b>{0}</b>'</br>from shopping list</br>'<b>{1}</b>'?",
                    DELETE_PENDING_TITLE: "Remove product",
                    DELETE_PRODUCT_BODY: "Do you want to delete the product</br>'<b>{0}</b>'?",
                    DELETE_PRODUCT_TITLE: "Delete product",
                    DELETE_REGISTER_BODY: "Do you want to delete the selected register?",
                    DELETE_REGISTER_TITLE: "Delete register",
                    DELETING_DATA: "Deleting",
                    DESCRIPTION: "Description",
                    EDIT: "Edit",
                    EDIT_LIST: "Edit Shopping List",
                    EDIT_PRODUCT: "Edit Product",
                    EDIT_REGISTER: "Edit Row",
                    END_DATE: "End Date",
                    ERROR_DATABASE: "Unexpected error occurred on database.",
                    ERROR_REGISTERED: "'<b>{0}</b>'</br>already exists or it's in historical record!!!</br></br>(MaLlista does not allow the repetition of names)",
                    ESTABLISHMENT: "Establishment",
                    ESTABLISHMENTS: "Establishments",
                    GENERATING_REPORT: "Generating report",
                    HOME: "Home",
                    IDENTIFIER: "Identifier",
                    IMAGE: "Image",
                    INITIALIZING: "Initializing",
                    INVALID_FORM: "Incorrect data!!!",
                    LANGUAGE: "Language",
                    LATITUDE: "Latitude",
                    LIST_NAME: "Shopping list name",
                    LISTS: "Shopping Lists",
                    LOADING_DATA: "Loading data",
                    LONGITUDE: "Longitude",
                    MAINTENANCE: "Maintenance",
                    MENU_TOOLS: "Tools",
                    MESSAGE_TITLE: "Message from MaLlista",
                    MODIFICATION_DATE: "Date last modification",
                    MODIFICATION_TIME: "Time last modification",
                    NAME: "Name",
                    NAME_REQUIRED: "Please, indicate the name",
                    NO_DATA_FOUND: "No data found!!!",
                    NO_LIST_FOUND: "No shopping list found!!!",
                    NO_PRODUCT_FOUND: "No products found!!!",
                    NO_REGISTER_FOUND: "No registers found!!!",
                    NO_ROW_SELECTED: "Please, select a row!!!",
                    NONE: "Not indicated",
                    PENDING: "Pending",
                    PREFERRED_ESTABLISHMENT: "Preferred establishment",
                    PRODUCT: "Product",
                    PRODUCT_NAME: "Product name",
                    PRODUCT_REMARKS: "Product remarks",
                    PRODUCTS: "Products",
                    PURCHASED_PRODUCTS_PER_PERIOD: "Purchased Products per Period",
                    PURCHASED_QTY: "Purchased quantity",
                    PURCHASES: "Purchases",
                    QUANTITY: "Quantity",
                    REMARKS: "Remarks",
                    REPORT_RANGE: "From {0} to {1}",
                    REQUESTED_QTY: "Requested quantity",
                    REQUIRED: "Required",
                    RUN_REPORT: "Generate Report",
                    SAVE: "Save",
                    SAVING_DATA: "Saving",
                    SELECT_DATE: "Select Date",
                    SET: "OK",
                    SETTINGS: "Settings",
                    SHOPPING_LIST: "Shopping List",
                    SHOPPING_LIST_PRODUCTS: "Pending products",
                    SHOPPING_LIST_REMARKS: "Shopping list remarks",
                    SHOPPING_LISTS: "Shopping lists",
                    SHOW_LIST: "Shopping List Details",
                    SHOW_PENDING: "Pending Product Details",
                    SHOW_PICTURE_IN_PENDING: "Show pictures in Pending",
                    SHOW_PICTURE_IN_PRODUCT: "Show pictures in Products",
                    SHOW_PRODUCT: "Product Details",
                    START_DATE: "Start Date",
                    STATISTICS: "Statistics",
                    TIME: "Time",
                    TODAY: "Today",
                    TOTAL_AMOUNT: "Total Amount",
                    TOTAL_AMOUNT_PER_BRAND: "Total Amount per Brand",
                    TOTAL_AMOUNT_PER_CATEGORY: "Total Amount per Category",
                    TOTAL_AMOUNT_PER_ESTABLISHMENT: "Total Amount per Establishment",
                    TOTAL_AMOUNT_PER_PERIOD: "Total Amount per Period",
                    TOTAL_PERIOD: "Total period",
                    UNABLE_TO_DELETE: "Unable to delete register in this table",
                    UNEXPECTED_ERROR: "Unexpected error!!!",
                    UNIT_PRICE: "Unit Price",
                    UNITS: "Units",
                    VIEW_DETAILS: "Show",
                }
            },
            //CASTELLANO
            {
                name: "Castellano",
                id: "es",
                tokens: {
                    ABOUT: "Acerca de MaLlista",
                    ABOUT_LINE_1: "Creada por Josep Antoni Casas Lopez<br />como Trabajo Fin de Carrera<br />Ingeniaría Técnica de Informática de Gestión<br />Universitat Oberta de Catalunya",
                    ABOUT_LINE_2: "Consultores:<br />Antonio Rodríguez Gutiérrez<br />Carlos Sánchez Rosa",
                    ABOUT_LINE_3: "Agradecimientos especiales a:",
                    ABOUT_LINE_4: "<i>Isa, Eder y Raquel</i>, por todo el apoyo que siempre me han ofrecido.",
                    ACCEPT: "Aceptar",
                    ACTIVATED: "Activado",
                    ALL_LISTS: "Todas las listas",
                    APP_NAME: "MaLlista",
                    APP_VERSION: "Versión {0}",
                    BRAND: "Marca",
                    BRANDS: "Marcas",
                    BUY: "Comprar",
                    BUY_PRODUCT: "Comprar Producto",
                    CANCEL: "Cancelar",
                    CATEGORY: "Categoría",
                    CATEGORIES: "Categorías",
                    CLOSE: "Cerrar",
                    CODE: "Código",
                    CREATE_LIST: "Crear Nueva Lista",
                    CREATE_PENDING: "Añadir Producto a Pendiente",
                    CREATE_PRODUCT: "Crear Producto",
                    CREATE_REGISTER: "Añadir Fila",
                    CREATION_DATE: "Fecha creación",
                    CREATION_TIME: "Hora creación",
                    DATE: "Fecha",
                    DELETE: "Eliminar",
                    DELETE_LIST_BODY: "¿Estas seguro de que quieres eliminar la lista de la compra</br>'<b>{0}</b>'?",
                    DELETE_LIST_TITLE: "Eliminar lista",
                    DELETE_PENDING_BODY: "¿Estas seguro de que quieres quitar el producto</br>'<b>{0}</b>'</br>de la lista de la compra</br>'<b>{1}</b>'?",
                    DELETE_PENDING_TITLE: "Quitar producto",
                    DELETE_PRODUCT_BODY: "¿Estas seguro de que quieres eliminar el producto</br>'<b>{0}</b>'?",
                    DELETE_PRODUCT_TITLE: "Eliminar producto",
                    DELETE_REGISTER_BODY: "¿Estas seguro de que quieres eliminar el registro seleccionado?",
                    DELETE_REGISTER_TITLE: "Eliminar registro",
                    DELETING_DATA: "Eliminando",
                    DESCRIPTION: "Descripción",
                    EDIT: "Modificar",
                    EDIT_LIST: "Modificar Lista",
                    EDIT_PRODUCT: "Modificar Producto",
                    EDIT_REGISTER: "Modificar Fila",
                    END_DATE: "Fecha Final",
                    ESTABLISHMENTS: "Establecimientos",
                    ERROR_DATABASE: "Se ha producido un error en la base de datos.",
                    ERROR_REGISTERED: "¡¡¡'<b>{0}</b>'</br>ya existe o forma parte del archivo histórico!!!</br></br>(MaLlista no permite la repetición de nombres)",
                    ESTABLISHMENT: "Establecimiento",
                    GENERATING_REPORT: "Generando el informe",
                    HOME: "Inicio",
                    IDENTIFIER: "Identificador",
                    IMAGE: "Imagen",
                    INITIALIZING: "Preparando el inicio",
                    INVALID_FORM: "Los datos del formulario no son correctos!!!",
                    LANGUAGE: "Idioma",
                    LATITUDE: "Latitud",
                    LIST_NAME: "Nombre de la lista",
                    LISTS: "Listas",
                    LOADING_DATA: "Cargando datos",
                    LONGITUDE: "Longitud",
                    MAINTENANCE: "Mantenimiento",
                    MENU_TOOLS: "Herramientas",
                    MESSAGE_TITLE: "Mensaje de MaLlista",
                    MODIFICATION_DATE: "Fecha última modificación",
                    MODIFICATION_TIME: "Hora última modificación",
                    NAME: "Nombre",
                    NAME_REQUIRED: "Por favor, indica el nombre",
                    NO_DATA_FOUND: "¡¡¡No se han encontrado datos!!!",
                    NO_LIST_FOUND: "¡¡¡No se han encontrado listas!!!",
                    NO_PRODUCT_FOUND: "¡¡¡No se han encontrado productos!!!",
                    NO_REGISTER_FOUND: "¡¡¡No se han encontrado registros!!!",
                    NO_ROW_SELECTED: "¡¡¡Por favor, selecciona una fila!!!",
                    NONE: "Sin especificar",
                    PENDING: "Pendiente",
                    PREFERRED_ESTABLISHMENT: "Establecimiento preferido",
                    PRODUCT: "Producto",
                    PRODUCT_NAME: "Nombre del producto",
                    PRODUCT_REMARKS: "Observaciones del producto",
                    PRODUCTS: "Productos",
                    PURCHASED_QTY: "Cantidat comprada",
                    PURCHASED_PRODUCTS_PER_PERIOD: "Productos Comprados por Período",
                    QUANTITY: "Cantidad",
                    PURCHASES: "Compras",
                    REMARKS: "Observaciones",
                    REPORT_RANGE: "Del {0} al {1}",
                    REQUESTED_QTY: "Cantidad a comprar",
                    REQUIRED: "Requerido",
                    RUN_REPORT: "Generar Informe",
                    SAVE: "Guardar",
                    SAVING_DATA: "Grabando",
                    SELECT_DATE: "Seleccionar Fecha",
                    SET: "OK",
                    SETTINGS: "Configuración",
                    SHOPPING_LIST: "Lista de la Compra",
                    SHOPPING_LIST_PRODUCTS: "Productos pendientes",
                    SHOPPING_LIST_REMARKS: "Observaciones de la lista de la compra",
                    SHOPPING_LISTS: "Listas de la compra",
                    SHOW_LIST: "Detalles de la Lista",
                    SHOW_PENDING: "Detalles del Producto Pendiente",
                    SHOW_PICTURE_IN_PENDING: "Mostrar imágenes en Pendientes",
                    SHOW_PICTURE_IN_PRODUCT: "Mostrar imágenes en Productos",
                    SHOW_PRODUCT: "Detalles del Producto",
                    START_DATE: "Fecha de Inicio",
                    STATISTICS: "Estadísticas",
                    TIME: "Hora",
                    TODAY: "Hoy",
                    TOTAL_AMOUNT: "Importe total",
                    TOTAL_AMOUNT_PER_BRAND: "Importe Gastado por Marca",
                    TOTAL_AMOUNT_PER_CATEGORY: "Importe Gastado por Categoría",
                    TOTAL_AMOUNT_PER_ESTABLISHMENT: "Importe Gastado por Establecimiento",
                    TOTAL_AMOUNT_PER_PERIOD: "Importe Gastado por Período",
                    TOTAL_PERIOD: "Total período",
                    UNABLE_TO_DELETE: "No se pueden eliminar los registros de esta tabla",
                    UNEXPECTED_ERROR: "¡¡¡Se ha producido un error inesperado!!!",
                    UNIT_PRICE: "Precio Unitario",
                    UNITS: "Unidades",
                    VIEW_DETAILS: "Mostrar",
                }
            }
        ];
        //Format a text replacing {n} with the corresponding arg
        self._format = function (text, args) {
            if (!angular.isArray(args))
                args = [args];

            if (text != undefined && text != null) {
                return text.replace(/\{(\d+)\}/g, function (match, capture) {
                    return args[1 * capture];
                });
            }
            return "";
        }
        //Get the current language
        self._getCurrentLan = function () {
            if (self._getLanIds().indexOf(currentLan) < 0)
                currentLan = defaultLan;
            return currentLan;
        }
        //Get a list with all available languages
        self._getLanguageList =  function () {
            var result = null;
            result = [];
            angular.forEach(languages, function (item) {
                result.push({ id: item.id, name: item.name, selected: item.id == currentLan });
            });
            return result;
        }
        //Get all languages
        self._getLanIds = function () {
            var result = [];
            var i = 0;
            angular.forEach(languages, function (item) {
                result[i] = item.id;
                i++;
            })
            return result;
        }
        //Get the month list
        self._getMonthList = function () {
            var result = [];
            switch (currentLan) {
                case 'ca':
                    result = ["Gener", "Febrer", "Març", "Abril", "Maig", "Juny", "Juliol", "Agost", "Setembre", "Octubre", "Novembre", "Desembre"];
                    break;
                case 'en':
                    result = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];

                    break;
                case 'es':
                    result = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];
                    break;
            }
            return result;
        }
        //Get a month name
        self._getMonthName = function (month) {
            var months = self._getMonthList();
            return months[month - 1];
        }
        //Get the translation for a token
        self._getToken = function (token, params) {
            var result = token;
            angular.forEach(languages, function (item) {
                if (item.id == self._getCurrentLan()) {
                    angular.forEach(item.tokens, function (value, key) {
                        if (key == token)
                            result = value;
                    });
                }
            });
            if (params != undefined)
                result = self._format(result, params);
            return result;
        }
        //Get the day list
        self._getWeekDayList = function (){
            var result = [];
            switch (currentLan) {
                case 'ca':
                    result = ["dg", "dl", "dm", "dc", "dj", "dv", "ds"];
                    break;
                case 'en':
                    result = ["su", "mo", "tu", "we", "th", "fr", "sa"];
                    break;
                case 'es':
                    result = ["do", "lu", "ma", "mi", "ju", "vi", "sa"];
                    break;
            }
            return result;
        }
        //Set the current language
        self._setCurrentLan = function (lan) {
            if (self._getLanIds().indexOf(lan) >= 0)
                currentLan = lan;
        }
        //Service's public methods
        return {
            getToken: function (token, params) {
                return self._getToken(token, params);
            },
            getCurrentLanguage: function () {
                return self._getCurrentLan();
            },
            setCurrentLanguage: function (lan) {
                return self._setCurrentLan(lan);
            },
            getLanguageList: function () {
                return self._getLanguageList();
            },
            getMonthName: function(month){
                return self._getMonthName(month);
            },
            getMonthList: function (){
                return self._getMonthList();
            },
            getWeekDayList: function(){
                return self._getWeekDayList();
            },
            format: function (text, args) {
                return self._format(text, args);
            }
        };
    }]);//end module
