﻿angular.module('mallista.items', [])

    //It represents a maintenance item
    .factory('MaintenanceItem', [function () {
        var item = {};
        item.id = null;
        item.activated = 0;
        item.brandId = null;
        item.categoryId = null;
        item.cDate = null;
        item.clau = null;
        item.code = null;
        item.creationDate = null;
        item.creationTime = null;
        item.description = null;
        item.establishmentId = null;
        item.fieldList = null;
        item.image = null;
        item.isActivated = false;
        item.isEdition = false;
        item.latitude = null;
        item.longitude = null;
        item.mDate = null;
        item.modificationDate = null;
        item.modificationTime = null;
        item.name = null;
        item.pDate = null;
        item.productId = null;
        item.purchaseDate = null;
        item.purchasedQty = 0;
        item.remarks = null;
        item.requestedQty = 0;
        item.shoppingListId = null;
        item.table = null;
        item.tableDescription = null;
        item.totalAmount = 0;
        item.unitPrice = 0;
        item.valid = false;
        item.valor = false;
        item.clear = function () {
            item.id = null;
            item.activated = 0;
            item.brandId = null;
            item.categoryId = null;
            item.cDate = null;
            item.code = null;
            item.creationDate = null;
            item.creationTime = null;
            item.description = null;
            item.establishmentId = null;
            item.fieldList = null;
            item.image = null;
            item.isActivated = false;
            item.isEdition = false;
            item.latitude = null;
            item.longitude = null;
            item.mDate = null;
            item.modificationDate = null;
            item.modificationTime = null;
            item.name = null;
            item.pDate = null;
            item.productId = null;
            item.purchaseDate = null;
            item.purchasedQty = 0;
            item.remarks = null;
            item.requestedQty = 0;
            item.shoppingListId = null;
            item.table = null;
            item.tableDescription = null;
            item.totalAmount = 0;
            item.unitPrice = 0;
            item.valid = false;
        }
        return item;
    }])

    //It represents a product of a shopping list
    .factory('PendingItem', [function () {
        var item = {};
        item.valid = false;
        item.id = null;
        item.shoppingListId = null;
        item.productId = null;
        item.brandId = null;
        item.brandName = "";
        item.categoryId = null;
        item.categoryName = "";
        item.code = "";
        item.creationDate = "";
        item.establishmentId = null;
        item.establishmentName = "";
        item.image = "";
        item.isEdition = false;
        item.modificationDate = "";
        item.productName = "";
        item.productRemarks = "";
        item.purchasedQty = 0;
        item.requestedQty = 0;
        item.shoppingListName = "";
        item.shoppingListRemaks = "";
        item.title = "";
        item.clear = function () {
            item.valid = false;
            item.id = null;
            item.shoppingListId = null;
            item.productId = null;
            item.brandId = null;
            item.brandName = "";
            item.categoryId = null;
            item.categoryName = "";
            item.code = "";
            item.creationDate = "";
            item.establishmentId = null;
            item.establishmentName = "";
            item.image = "";
            item.isEdition = false;
            item.modificationDate = "";
            item.productName = "";
            item.productRemarks = "";
            item.purchasedQty = 0;
            item.requestedQty = 0;
            item.shoppingListName = "";
            item.shoppingListRemaks = "";
            item.title = "";
        }
        return item;
    }])

    //It represents a product
    .factory('ProductItem', [function () {
        var item = {};
        item.valid = false;
        item.id = null;
        item.activated = 0;
        item.brandId = null;
        item.categoryId = null;
        item.code = "";
        item.creationDate = "";
        item.establishmentId = null;
        item.image = "";
        item.isEdition = false;
        item.modificationDate = "";
        item.name = "";
        item.remarks = "";
        item.title = "";
        item.clear = function () {
            item.valid = false;
            item.id = null;
            item.activated = 0;
            item.brandId = null;
            item.categoryId = null;
            item.code = "";
            item.creationDate = "";
            item.establishmentId = null;
            item.image = "";
            item.isEdition = false;
            item.modificationDate = "";
            item.name = "";
            item.remarks = "";
            item.title = "";
        }
        return item;
    }])

    //It represents a report
    .factory('ReportItem', ['$filter', function ($filter) {
        var item = {};
        item.valid = false;
        item.id = 0;
        item.endDate = new Date($filter('date')(new Date(), "yyyy"), 11, 31);
        item.name = "";
        item.startDate = new Date($filter('date')(new Date(), "yyyy"), 0, 1);
        item.clear = function (keepRange) {
            item.valid = false;
            item.id = 0;
            item.name = "";
            if (keepRange != true) {
                item.endDate = new Date($filter('date')(new Date(), "yyyy"), 11, 31);
                item.startDate = new Date($filter('date')(new Date(), "yyyy"), 0, 1);
            }
        }
        item.setRange = function (startDate, endDate) {
            item.startDate = startDate;
            item.endDate = endDate;
        }
        return item;
    }])

    //It represents a shopping list
    .factory('ShoppingListItem', [function () {
        var item = {};
        item.valid = false;
        item.id = 0;
        item.activated = 0;
        item.creationDate = "";
        item.isEdition = false;
        item.modificationDate = "";
        item.name = "";
        item.remarks = "";
        item.clear = function () {
            item.valid = false;
            item.id = 0;
            item.activated = 0;
            item.creationDate = "";
            item.isEdition = false;
            item.modificationDate = "";
            item.name = "";
            item.remarks = "";
        }
        return item;
    }])

; //end module